/***************************************************************
 * Name:      editartexto.cpp
 * Purpose:   Code for Dialog boxSizer
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-04-11
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#include "editartexto.h"


BEGIN_EVENT_TABLE(editarUsuario, wxDialog)
    EVT_CLOSE(editarUsuario::OnClose)
END_EVENT_TABLE()

editarUsuario::editarUsuario(wxWindow *wnd, datosUsuario &datos)
    : wxDialog(wnd, -1, _T("Ejemplo edición de usuario"))
{
    wxBoxSizer *boxVertical;
    wxBoxSizer *boxHorizontal;
    wxTextCtrl *edit;

    wxTextValidator valNombre = wxTextValidator(wxFILTER_ALPHA | wxFILTER_SPACE, &datos.nombre);
    wxTextValidator valEmail = wxTextValidator(wxFILTER_ALPHANUMERIC | wxFILTER_INCLUDE_CHAR_LIST, &datos.email);
    wxTextValidator valTelefono = wxTextValidator(wxFILTER_NUMERIC, &datos.telefono);

    valEmail.AddCharIncludes("@.");

    boxVertical = new wxBoxSizer(wxVERTICAL);

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    edit = new wxTextCtrl(this, idNombre, wxEmptyString, wxDefaultPosition, wxSize(200, wxDefaultCoord), 0, valNombre);
    boxHorizontal->Add(new wxStaticText(this, wxID_ANY, _T("&Nombre:")), wxSizerFlags().Border());
    boxHorizontal->Add(edit, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    edit->SetHint(_T("nombre apellido"));

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    edit = new wxTextCtrl(this, idEmail, wxEmptyString, wxDefaultPosition, wxSize(200, wxDefaultCoord), 0, valEmail);
    boxHorizontal->Add(new wxStaticText(this, wxID_ANY, _T("&Email:")), wxSizerFlags().Border());
    boxHorizontal->Add(edit, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    edit->SetHint(_T("nombre@dominio.com"));

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    edit = new wxTextCtrl(this, idTelefono, wxEmptyString, wxDefaultPosition, wxSize(200, wxDefaultCoord), 0, valTelefono);
    boxHorizontal->Add(new wxStaticText(this, wxID_ANY, _T("&Telefono:")), wxSizerFlags().Border());
    boxHorizontal->Add(edit, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    edit->SetHint(_T("123456789"));

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK | wxCANCEL), wxSizerFlags().Border());

    SetSizerAndFit(boxVertical);
}

void editarUsuario::OnClose(wxCloseEvent &event)
{
    Destroy();
}
