/***************************************************************
 * Name:      limitar.cpp
 * Purpose:   Code for Dialog boxSizer
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-11-01
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#include "limitar.h"

BEGIN_EVENT_TABLE(textoLimitado, wxDialog)
    EVT_CLOSE(textoLimitado::OnClose)
    EVT_TEXT_MAXLEN(idTexto, textoLimitado::OnMaxTexto)
END_EVENT_TABLE()

textoLimitado::textoLimitado(wxWindow *wnd, datosLimitar &datos)
    : wxDialog(wnd, -1, _T("Ejemplo captura texto limitado"))
{
    wxBoxSizer *boxVertical;
    wxBoxSizer *boxHorizontal;

    wxTextValidator valTexto = wxTextValidator(wxFILTER_NONE, &datos.texto);

    boxVertical = new wxBoxSizer(wxVERTICAL);

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    ctrlTexto = new wxTextCtrl(this, idTexto, wxEmptyString, wxDefaultPosition, wxSize(200, wxDefaultCoord), 0, valTexto);
    boxHorizontal->Add(new wxStaticText(this, wxID_ANY, _T("&Texto:")), wxSizerFlags().Border());
    boxHorizontal->Add(ctrlTexto, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());
    ctrlTexto->SetMaxLength(10);

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK | wxCANCEL), wxSizerFlags().Border());

    SetSizerAndFit(boxVertical);
}

void textoLimitado::OnClose(wxCloseEvent &event)
{
    Destroy();
}

void textoLimitado::OnMaxTexto(wxCommandEvent& event)
{
    wxMessageBox(_T("La longitud máxima del texto es de 10 caracteres"), _T("Texto limitado"));
}
